`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    11:13:51 05/20/2022 
// Design Name: 
// Module Name:    Seven_seg_test 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module Seven_seg_test(input clk,reset,input [15:0] SLIDE_SW,output sel_disp1,sel_disp2,sel_disp3,sel_disp4,output [7:0] seg
    );
wire [18:0] bcd;
wire [15:0] bin;
SEVEN_SEGMENT seg2(clk,reset,sel_disp1,sel_disp2,sel_disp3,sel_disp4,bcd[15:12],bcd[11:8],bcd[7:4],bcd[3:0],seg
    );
binbcd16 conv(SLIDE_SW,bcd);
//assign bin = {8'b00000000,SLIDE_SW[0],SLIDE_SW[1],SLIDE_SW[2],SLIDE_SW[3],SLIDE_SW[4],SLIDE_SW[5],SLIDE_SW[6],SLIDE_SW[7]};
endmodule

module SEVEN_SEGMENT(
input clk,reset,
output reg sel_disp1,sel_disp2,sel_disp3,sel_disp4,
//output SIG_PD,
input [3:0] data_disp_1,data_disp_2,data_disp_3,data_disp_4,output reg [7:0] seg
    );
reg [15:0] COUNT;
reg [3:0] COUNT_BCD;
reg [3:0] BCD;
wire CLK_7_SIG;
always @ (posedge clk or  posedge reset)
begin
if (reset)
COUNT <= 0;
else 
COUNT <= COUNT + 1;
end

assign CLK_7_SIG = COUNT[15];

always @(posedge CLK_7_SIG or posedge reset)
begin
if (reset == 1 || BCD == 4'b0100)
BCD <= 0;
else 
BCD <= BCD + 1;
end

always @(posedge CLK_7_SIG )
begin
	case (BCD)
		3'b000 : begin
			sel_disp1 <= 1;
			sel_disp2 <= 0;
			sel_disp3 <= 0;
			sel_disp4 <= 0;
			COUNT_BCD <=data_disp_1; end
		3'b001 : begin
			sel_disp1 <= 0;
			sel_disp2 <= 1;
			sel_disp3 <= 0;
			sel_disp4 <= 0;
			COUNT_BCD <=data_disp_2; end
	
		3'b010 : begin
			sel_disp1 <= 0;
			sel_disp2 <= 0;
			sel_disp3 <= 1;
			sel_disp4 <= 0;
			COUNT_BCD <=data_disp_3; end
		3'b011 : begin
			sel_disp1 <= 0;
			sel_disp2 <= 0;
			sel_disp3 <= 0;
			sel_disp4 <= 1;
			COUNT_BCD <=data_disp_4; end
default : begin
			sel_disp1 <= 0;
			sel_disp2 <= 0;
			sel_disp3 <= 0;
			sel_disp4 <= 0;
			COUNT_BCD <=data_disp_1; end
	endcase end
	
	always @* begin
	case(COUNT_BCD)
	   4'b0000 : seg =  8'b11000000;   //0
		4'b0001: seg =  8'b11111001;   //1
		4'b0010 : seg =  8'b10100100;  //2
		4'b0011 : seg =  8'b10110000;    //3
		4'b0100 : seg =  8'b10011001;   //4
		4'b0101 : seg =  8'b10010010;  //5
		4'b0110 : seg =  8'b10000010;    //6
		4'b0111 : seg =  8'b11111000;   //7
		4'b1000 : seg =  8'b10000000;   //8
		4'b1001 : seg =  8'b10010000;    //9
		4'b1010 : seg =  8'b10001000;    //A
		4'b1011 : seg =  8'b10000011;    //b
		4'b1100 : seg =  8'b11000110;    //C
		4'b1101 : seg =  8'b10100001;   //d
		4'b1110 : seg =  8'b10000110;    //E
		4'b1111 : seg =  8'b10001110;    //F
   endcase end
//assign SIG_PD = 1;
endmodule

 module binbcd16(bin,bcd);
	input [15:0] bin;
	output [18:0] bcd;

	reg [18:0] bcd;
	reg [35:0] x;
	integer i;
  always @(bin)
  begin
    for(i = 0; i <= 35; i = i+1)
	x[i] = 0;
    x[18:3] = bin;
    for(i = 0; i <= 12; i = i+1)
    begin
	if(x[19:16] > 4)	
		x[19:16] = x[19:16] + 3;
	if(x[23:20] > 4) 	
		x[23:20] = x[23:20] + 3;
	if(x[27:24] > 4) 	
		x[27:24] = x[27:24] + 3;
	if(x[31:28] > 4) 	
		x[31:28] = x[31:28] + 3;
	if(x[35:32] > 4) 	
		x[35:32] = x[35:32] + 3;
	x[35:1] = x[34:0];
    end      
    bcd = x[35:16];	
  end 
endmodule



